#ifdef __APPLE__
  #include <GLUT/glut.h>
#else
  #include <GL/glut.h>
#endif

#include <stdio.h>
#include <stdlib.h>

#define RND ((float)rand( )/RAND_MAX)

#define True  1
#define False 0
#define WINSIZE 1000
#define ROWSIZE 3000
#define X_OFFSET ROWSIZE/4
#define Y_OFFSET ROWSIZE/4

void display(void);
void idle(void);
void init(void);
void clear(void);
int  main(int argc, char** argv);

int mouseX, mouseY;
int pmouseX, pmouseY;


short *row, *old_row;

short rule(int left, int top, int right)
{
    return left ^ right;
}

void kernel(short * current_row, short * old_row, int row_size, int index)
{
	if(index < row_size)
	{
		current_row[index] = rule(old_row[index-1], old_row[index], old_row[index+1]);
	}
}

void display( )
{
    int i, j;
	short out;
	short * tmp;
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glPushMatrix();
	glTranslatef(mouseX - pmouseX, 0.0, 0.0);
	glTranslatef(0.0, mouseY - pmouseY, 0.0);
    glBegin(GL_POINTS);
		for(j = 0; j < ROWSIZE; j++)
		{
			for(i = 1; i < ROWSIZE-1; i++)
			{
				kernel(row, old_row, ROWSIZE-1, i);
				out = old_row[i];
				if(out)
				{
					glColor3f(0.3, 0.9, 0.1);
				}
				else
				{
					glColor3f(0.3, 0.3, 0.3);
				}
				old_row[i] = out;
				glVertex3f(i - X_OFFSET, Y_OFFSET - j, 0.0);
			}
			tmp = row;
			row = old_row;
			old_row = tmp;
		}
    glEnd( );
	glPopMatrix();
    glutSwapBuffers( );
	//mouse_x = 0;
	//mouse_y = 0;
	clear( );
}

void clear( )
{
	int i;
	for(i = 0; i < ROWSIZE; i++)
	{
		old_row[i] = 0;
	}
	old_row[ROWSIZE/2] = 1;
}

void idle( )
{
    glutPostRedisplay( );
}

void mouse(int button, int state, int x, int y)
{
	if(state)
	{
		pmouseX = mouseX;
		pmouseY = mouseY;
		mouseX = x;
		mouseY = y;
	}
}

void init( )
{
    glClearColor(0.0, 0.0, 0.0, 0.0);
    glMatrixMode(GL_FLAT);
    glLoadIdentity( );
    glOrtho(- WINSIZE, WINSIZE, - WINSIZE, WINSIZE, -2.0, 2.0);
    glClear(GL_COLOR_BUFFER_BIT);
	
	row = calloc(ROWSIZE, sizeof(short));
	old_row = calloc(ROWSIZE, sizeof(short));
	old_row[ROWSIZE/2] = 1;
	
	mouseX = 0;
	mouseY = 0;
	pmouseY = 0;
	pmouseX = 0;
}

int main(int argc, char** argv)
{
    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
    glutInitWindowSize(WINSIZE, WINSIZE);
    glutInitWindowPosition(0,0);
    glutCreateWindow("Rule 30 Cellular Automata");
    init( );
    glutDisplayFunc(display);
	glutMouseFunc(mouse);
    glutIdleFunc(idle);
    glutMainLoop( );
    return 0;
}
